/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.scorm;

import java.io.File;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.core.util.InstallerXmlUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;
import jp.co.ntt.lms.installer.util.StringUtil;
import jp.co.ntt.lms.installer.util.XmlUtil;

import org.w3c.dom.Document;

/**
 * SCORM Engine環境設定について入力するアクション・クラス。
 * @author T.Nishiki
 */
public class ScormEngineInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(ScormEngineInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしないのでfalseを戻します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return falseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * SCORM Engine環境設定について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return ScormEngineInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see ScormEngineInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {

		LoggerUtil.methodHead(_logger, "action(InstallerValues)");

		// 今回入力データ
		ScormEngineInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			ScormEngineInputValue defaultValue = getDefaultValue(values);
			// タイトル表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "ScormEngineInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * SCORM Engine環境設定の書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をScormEngineInputValueとして戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ScormEngineInputValue readInputValue(
			InstallerValues values, ScormEngineInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues)");

		ScormEngineInputValue inputValue = null;
		try {
			inputValue = new ScormEngineInputValue();
			// =================================================================
			// SCORMサーバ名
			String scormServerName = null;
			while (true) {
				scormServerName = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.scormServerName",
						defaultValue.getScormServerName());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
						scormServerName, values,
						"ScormEngineInputAction.error.scormServerName.empty")) {
					continue;
				}
				break;
			}
			inputValue.setScormServerName(scormServerName);
			// =================================================================
			// SCORMポート番号
			String scormServerPort = null;
			while (true) {
				scormServerPort = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.scormServerPort",
						defaultValue.getScormServerPort());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
						scormServerPort, values,
						"ScormEngineInputAction.error.scormServerPort.empty")) {
					continue;
				}
				break;
			}
			inputValue.setScormServerPort(scormServerPort);
			// =================================================================
			// アプリケーション・ベースURI
			String applicationBaseURI = null;
			while (true) {
				applicationBaseURI = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.applicationBaseURI",
						defaultValue.getApplicationBaseURI());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					applicationBaseURI, values,
					"ScormEngineInputAction.error.applicationBaseURI.empty")) {
					continue;
				}
				break;
			}
			inputValue.setApplicationBaseURI(applicationBaseURI);
			// =================================================================
			// 教材を格納するベースディレクトリ・パス
			String contentsBaseURL = null;
			while (true) {
				contentsBaseURL = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.contentsBaseURL",
						defaultValue.getContentsBaseURL());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					contentsBaseURL, values,
					"ScormEngineInputAction.error.contentsBaseURL.empty")) {
					continue;
				}
				break;
			}
			inputValue.setContentsBaseURL(contentsBaseURL);
			// =================================================================
			// 学習ログ出力ディレクトリ・パス
			String learningLogBaseURL = null;
			while (true) {
				learningLogBaseURL = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.learningLogBaseURL",
						defaultValue.getLearningLogBaseURL());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					learningLogBaseURL, values,
					"ScormEngineInputAction.error.learningLogBaseURL.empty")) {
					continue;
				}
				break;
			}
			inputValue.setLearningLogBaseURL(learningLogBaseURL);
			// =================================================================
			// 中断情報出力ディレクトリ・パス
			String resumeDataBaseURL = null;
			while (true) {
				resumeDataBaseURL = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.resumeDataBaseURL",
						defaultValue.getResumeDataBaseURL());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					resumeDataBaseURL, values,
					"ScormEngineInputAction.error.resumeDataBaseURL.empty")) {
					continue;
				}
				break;
			}
			inputValue.setResumeDataBaseURL(resumeDataBaseURL);
			// =================================================================
			// デバッグログ出力ディレクトリ・パス
			String debugLogPath = null;
			while (true) {
				debugLogPath = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.debugLogPath",
						defaultValue.getDebugLogPath());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					debugLogPath, values,
					"ScormEngineInputAction.error.debugLogPath.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDebugLogPath(debugLogPath);
			// =================================================================
			// マネージャ・ホスト
			String managerHost = null;
			while (true) {
				managerHost = InstallerUiUtil.askUserInput(values,
						"ScormEngineInputAction.prompt.managerHost",
						defaultValue.getManagerHost());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(
					managerHost, values,
					"ScormEngineInputAction.error.managerHost.empty")) {
					continue;
				}
				break;
			}
			inputValue.setManagerHost(managerHost);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, ScormEngineInputValue inputValue)
			throws InstallerException {

		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, ScormEngineInputValue)");
		boolean confirm = false;
		try {
			InstallerUiUtil.outputConfirmTitle(values,
				"ScormEngineInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// SCORMサーバ名
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.scormServerName",
				inputValue.getScormServerName());
			// =================================================================
			// SCORMポート番号
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.scormServerPort",
				inputValue.getScormServerPort());
			// =================================================================
			// アプリケーションベースURI
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.applicationBaseURI",
				inputValue.getApplicationBaseURI());
			// =================================================================
			// 教材格納ベース・ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.contentsBaseURL",
				inputValue.getContentsBaseURL());
			// =================================================================
			// 学習ログファイル・ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.learningLogBaseURL",
				inputValue.getLearningLogBaseURL());
			// =================================================================
			// 中断情報ファイル・ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.resumeDataBaseURL",
				inputValue.getResumeDataBaseURL());
			// =================================================================
			// デバッグログファイル・ディレクトリ
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.debugLogPath",
				inputValue.getDebugLogPath());
			// =================================================================
			// マネージャ・ホスト名
			InstallerUiUtil.outputConfirm(values,
				"ScormEngineInputAction.confirm.managerHost",
				inputValue.getManagerHost());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "ScormEngineInputAction.confirm" );
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, ScormEngineInputValue)",
			confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をScormEngineInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ScormEngineInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		ScormEngineInputValue defaultValue = null;
		try {
			defaultValue = new ScormEngineInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
					defaultValue.getTargetFileKey());
			Document existDoc = null;
			if (existFile != null) {
				existDoc = XmlUtil.convertXmlFileToDocument(existFile);
			}
			// =================================================================
			// リソース（原本）の内容
			Document resourceDoc
				= InstallerXmlUtil.load(
					values, defaultValue.getTargetFileKey());
			////////////////////////////////////////////////////////////////////
			// デフォルト値の設定
			defaultValue = new ScormEngineInputValue();
			// =================================================================
			// サーブレットベースURLを取得して、
			// ホスト名、ポート番号、アプリケーションパスを抽出・取得します。
			String servletBaseURL
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_BASE_SERVLET_URL);
			String serverName = "";
			String serverPort = "";
			String applicationBaseURI = "";
			// 抽出するのは、既存ファイルとリソースに差異があるときのみ
			if (StringUtil.isEmpty(servletBaseURL) == false) {
				try {
					// プロトコル文字列の除去
					int protocolPos = servletBaseURL.indexOf(
						ScormEngineInputValue.PROTOCOL_HTTP);
					if (protocolPos >= 0) {
						servletBaseURL = servletBaseURL.substring(
							protocolPos
							+ ScormEngineInputValue.PROTOCOL_HTTP.length());
					}
					// ホスト名／ポート番号とパスを分ける
					int firstSlashPos = servletBaseURL.indexOf("/");
					String serverHostAndPort
						= servletBaseURL.substring(0, firstSlashPos);
					String path = servletBaseURL.substring(firstSlashPos);
					// ホスト名とポート番号を分ける
					int colonPos = serverHostAndPort.indexOf(":");
					if (colonPos < 0) {
						serverName = serverHostAndPort;
						serverPort = ScormEngineInputValue.DEFAULT_PORT_HTTP;
					}
					else {
						serverName = serverHostAndPort.substring(0, colonPos);
						serverPort = serverHostAndPort.substring(colonPos + 1);
					}
					// パスの中からアプリケーションベースパスを抽出
					int servletNamePos = path.indexOf(
							ScormEngineInputValue.PATH_SERVLET);
					if (servletNamePos < 0) {
						applicationBaseURI = path;
					}
					else {
						applicationBaseURI = path.substring(0, servletNamePos);
					}
				}
				catch (Exception e) {
					serverName = "";
					serverPort = "";
					applicationBaseURI = "";
				}
			}
			defaultValue.setScormServerName(serverName);
			defaultValue.setScormServerPort(serverPort);
			defaultValue.setApplicationBaseURI(applicationBaseURI);
			// =================================================================
			// 教材を格納するベースディレクトリ・パス
			String contentsBaseURL
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_CONTENTS_BASE_URL);
			defaultValue.setContentsBaseURL(contentsBaseURL);
			// =================================================================
			// 学習ログ出力ディレクトリ・パス
			String learningLogBaseURL
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_LEARNING_LOG_BASE_URL);
			defaultValue.setLearningLogBaseURL(learningLogBaseURL);
			// =================================================================
			// 中断情報出力ディレクトリ・パス
			String resumeDataBaseURL
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_RESUME_DATA_BASE_URL);
			defaultValue.setResumeDataBaseURL(resumeDataBaseURL);
			// =================================================================
			// デバッグログ出力ディレクトリ・パス
			String debugLogPath
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_DEBUG_LOG_PATH);
			defaultValue.setDebugLogPath(debugLogPath);
			// =================================================================
			// マネージャホスト名
			String managerHost
				= InstallerXmlUtil.determineInitialNodeValue(
					existDoc, resourceDoc,
					ScormEngineInputValue.XPATH_MANAGER_NAME);
			defaultValue.setManagerHost(managerHost);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
